#!/usr/bin/python

#
##
### MoThEr. Mommas gonna make all of your nightmares come true.
##                                                        PF
#
            
from eccez import *
from commons import camelName
from speaker import Speaker, init_speaker, RED, YELLOW, GREEN
from dbda import Psygres, init_dbda

#
##
###
#
# You can use the manager plugin to handle a set
# of child records, and to handle relations in a 
# magic way
# To use it, specify the dependencies:
#
#   class Foo(DbMother,MotherManager):
#       def __init__(self,.....):
#           DbMother.__init__(self,...
#
# but don't init the manager.
# You will have a set of useful functions.
# If you want more magic, you can run:
#
#   initChildManager(children_list)
#   initRelationManager(children_list)
#   initListManager(children_list)
#
###
##
#

def init_mother(pg_conn= None):

    if DbMother._mo_initialized:
        Speaker.log_error("Mother already initialized.")
        return

    init_speaker('conf.py')
    init_dbda(pg_conn)
    DbMother._mo_initialized= True
    DbMother.__init__= DbMother.__post_init__


#
##
### Mother Symbols
##
#

#
## MoThEr: init flags.
#

MO_NOA    = 0     # No Action
MO_DEL    = 1     # Del Action
MO_UP     = 2     # Update Action
MO_SAVE   = 3     # Save Action
MO_LOAD   = 4     # Load Action
MO_ULOAD  = 5     # Unsafe Load Action

MO_MAX_FLAG = MO_ULOAD

MO_BEFORE = 0
MO_AFTER  = 1

#
## MoThEr: SQL symbols.
#

SQL_DEFAULT = "MOTHER_SQL_DEFAULT"
SQL_NULL    =  None
SQL_TRUE    = "True"
SQL_FALSE   = "False"



#
##
### Begin MoThEr.
##
#

_MO_FLAGS_STRS = \
    ['MO_NOA','MO_DEL','MO_UP','MO_SAVE','MO_LOAD','MO_ULOAD']
_MO_FUCK=" MoThEr fucker!"

_FALSE_VALUES= [SQL_NULL,SQL_DEFAULT]

class DbMother(Psygres):
    """ The Holy MoThEr 
        An abstract class which represents a db Table.
    """
    _mo_initialized= False

    def _if_not_initialized(self):
        if not DbMother._mo_initialized:
            init_mother()
            DbMother.__init__= DbMother.__post_init__

    def __init__(self, store= {}, flag= MO_NOA, oid= None, dbda= None):
        """ __init__(dict_values, flag, oid, dbda, logger)

            Never set oid! Oid is for Box plugin only.
            With dbda and logger you can use your own
            atabase intefraces.
            By default, db-adapter classes
            are shared, persistent and already defined.
        """

        self._if_not_initialized()
        # This is an hack to bypass initialization control
        # after the first Mother initialization
        self.__post_init__(store, flag, oid, dbda)


    def __post_init__(self, store= {}, flag= MO_NOA, oid= None, dbda= None):

        # table_name is needed...
        if not hasattr(self, 'table_name'):
            self.log_int_raise("No table_name, %s", _MO_FUCK)

        self._if_not_initialized()

        # Useful var
        tbl= self.table_name

        self._do_nothing= lambda *args: None

        # self.fields is a list with TABLE fields.
        # self.pkeys is a list with primary keys for the TABLE.
        # You can set these vars in the child class or let
        # MoThEr assign them dynamically.
        if not hasattr(self, "fields"):
            try:
                from dbstruct import TABLE_FIELDS_DICT
                self.fields = TABLE_FIELDS_DICT[tbl]
                del TABLE_FIELDS_DICT
            except:
                self.log_int_raise(RED(
                    "dbstruct.py and rels.py have to "
                    "be created with dbmapper before "
                    "using Mother."))

        if not hasattr(self, "pkeys"):
            try:
                from dbstruct import TABLE_PKEYS_DICT
                self.pkeys = TABLE_PKEYS_DICT[tbl]
                del TABLE_PKEYS_DICT
            except:
                self.log_int_raise(RED(
                    "dbstruct.py and rels.py have to "
                    "be created with dbmapper before "
                    "using Mother."))

        # Frozeset!
        self.fields= frozenset(self.fields)
        self.pkeys= frozenset(self.pkeys)

        # Dynamic vars
        self.oid=oid

        # Mapping actions
        self._flag_actions={
            MO_UP: self.update,
            MO_NOA: self._do_nothing,
            MO_DEL: self.delete, 
            MO_SAVE: self.insert,
            MO_LOAD: self.load,
            MO_ULOAD: self.uload 
            }

        self._trigger_actions={
            MO_UP: self._update,
            MO_DEL: self._delete, 
            MO_SAVE: self._insert,
            MO_LOAD: self._load,
            }

        # Storing dict values with some controls depending on the 
        # initialization flag....
        self._initStore(store, flag)
        # ... and enjoy ;)

    def initTriggers(self):

        self.triggers_map= {}
        t= self.triggers_map
            
        for flag in [MO_UP, MO_LOAD, MO_SAVE, MO_DEL]:
            t[flag]= {}
            for when in [MO_AFTER, MO_BEFORE]:
                t[flag][when]= []

        self._trigger_initialized= True

    def _initStore(self,store,flag):
        """ _initStore(store,flag) --> None

        Inizialization of self._store depending on flag.
        """

        # Controls: trivial
        setK=set(store.keys())
        accio=self._invalidFields(setK)
        if accio:
            self.log_int_raise("Mth: invalid Key Values %s.",\
                                RED(str(accio)))

        self._moved=set([])
        self._store=store.copy()

        # Very Bad Flag. CRASH!
        if flag<0 or flag>MO_MAX_FLAG:
            self.log_int_raise("Mth: invalid Flag %s,%s",\
                        RED(_MO_FLAGS_STRS[flag]),_MO_FUCK)

        # Signal Mother that passed fields are
        # new fields
        self._moved= set([ \
            k for k in setK \
            if k not in self.pkeys])

        f=self._flag_actions[flag]
        f()

#
##
### Internal Core
##
#
    def _triggers_are_initialized(self):
        return hasattr(self, 'triggers_map')

    def _unvaluedPKeys(self):
        """ _unvaluedPKeys() --> set

        Returns the set of pkeys not valu'ed.
        NOTE: a pkeys is considere NOT VALUED if his value is 
        DEFAULT or NULL.
        """

        s=self._store
        return set([\
            k for k in self.pkeys\
            if not s.has_key(k)\
            or s[k] in _FALSE_VALUES])

    def _noPKeyFields(self):
        """ _noPKeyFields() --> set

        Returns the list of fields in store that are not pkeys.
        """
        return set(self._store.keys()) - self.pkeys

    def _invalidFields(self,fields):
        """ _invalidFields(fields) --> set

        field in fields are returned if they are not present
        in self.fields.
        """

        if type(fields) is not set:
            fields=set(fields)
        return fields - self.fields

    def _fieldsMissing(self):
        """ _fieldsMissing() --> set

        Returns the list of table fields not valu'ed in store.
        """
        return self.fields-set(self._store.keys())

       
    def _getOid(self):
        """ _getOid() --> self.oid
        """
        return self.oid

    def _afterInsert(self):
        """ _afterInsert() --> None

        Load from DB all pkeys values.
        Thinked for `SERIAL` type.
        Only for postgres!
        """
        pass

    def __str__(self):
        """ __str__() --> string 
        """
        u="Unset"
        res=("\t\nTable `%s`:\n\n"\
            % self.table_name)
        sk=self._store.keys()
        for k in self.fields:
            val=self._store.get(k,u)
            res+=("\t%20s ~ %s\n" % (k,str(val)))
        res+="\n\tOid is "
        res+=self.oid and str(self.oid) or u
        return res

#
##
### Sql Formatting
##
#

    def _sqlWhereOid(self):
        """ _sqlWhereOid() --> string

        Returns 'WHERE oid=self.oid' if self.oid. Crash otherwise.
        """
        if not self.oid:
            self.log_int_raise("Mth: NULL oid. Shouldn't be here.") 
        return (" WHERE oid=%d " % self.oid)

    def _sqlSelectWhat(self,s,table=None):
        """ _sqlSelectWhat(s) --> string 

        returns 'SELECT '+s+' from '+self.table_name
        """
        table=table or self.table_name
        return "SELECT %s from %s" % (s,table)

    def _sqlSelectFields(self,fields,table=None):
        """ _sqlSelectFields(fields) --> string

        Returns 'SELECT f, g ... from table'
        table defaults to self.table_name
        """
        sf=self._sqlFieldsNames(fields)
        return self._sqlSelectWhat(sf,table)
            
    def _sqlWhereWhat(self,s):
        """_sqlWhereWhat(,s) --> string

        returns 'WHERE '+s
        """
        return " WHERE %s" %s

    def _sqlFieldsNames(self,fields):
        """ _sqlFieldsNames(fields) --> string

        Returns 'field_1_name,...,field_2_name'
        """
        return ",".join(fields)

    def _sqlFieldsDicted(self,fields):
        """ _sqlFieldsDicted(fields) --> string

        Returns '%(f_1)s,...%(f_n)s'
        """
        tl=[("%%(%s)s" % f) for f in fields]
        return "("+ ",".join(tl) +")"

    def _sqlFieldsEq(self,fields,tbl=None):
        """ _sqlFieldsEq(fields) --> string

        Returns 'f1_name = %(f1_name)s AND f2_name = %(f2_name)s ...'
        """
        tbl=tbl or self.table_name
        tl=[" %s.%s = %%(%s)s" % (tbl,item,item) for item in fields]
        return " AND ".join(tl)

    def _sqlInsertWhat(self,s):
        """ _sqlInsertWhat(s) --> string

        Returns 'INSERT INTO self.table_name (s) VALUES'.
        NOTE: s will be ()'ed.
        """
        res=("INSERT INTO %s (%s) VALUES "\
            % (self.table_name,s))
        return res

    def _sqlInsertFields(self,fields):
        """ _sqlInsertFields(fields) --> string

        Returns INSERT INTO self.table_name (..fields..)
        """
        fn=self._sqlFieldsNames(fields)
        return self._sqlInsertWhat(fn)

    def _sqlUpdateWhat(self,s):
        """ _sqlUpdateWhat(s) --> string

        Returns 'UPDATE self.table_name SET s'.
        """
        res= "UPDATE %s SET %s " % (self.table_name,s)
        return res

    def _sqlFieldsComma(self,fields):
        """ _sqlFieldsComma(fields) --> string

        Returns 'f_1=%(f_1)s,f_2=%(f_2), ....'
        or 'f=DEFAULT, ...' if self._store[f]=SQL_DEFAULT
        """
        tl=[]
        for f in fields:
            if self._store[f]==SQL_DEFAULT:
                tl.append(f+" = DEFAULT")
            else:
                tl.append(f+(" = %%(%s)s" % f))
        return ','.join(tl)

    def _sqlUpdateFields(self,fields):
        """ _sqlUpdateFields(fields) --> string

        Returns 'UPDATE self.table_name SET f_1=%(f_1)s ...'
        or 'f_1=DEFAULT' if self._store[f_1]=SQL_DEFAULT.
        """
        s=self._sqlFieldsComma(fields)
        return self._sqlUpdateWhat(s)

    def _sqlDelete(self):
        """ _sqlDelete() --> string

        Returns 'DELETE FROM self.table_name'
        """
        return "DELETE FROM %s " % self.table_name

    def _sqlJoin(self,j_tbl,r_tbl,j_key,r_key):
        """ _sqlJoin(j_tbl,r_tbl,key) --> str

        Returns the join query.
        """

        s= " JOIN %s on " % r_tbl
        s+="AND".join(\
            [" %s.%s = %s.%s " % (r_tbl,v,j_tbl,k)
                for k,v in j_key.iteritems()])
        s+=" WHERE "
        s+="AND".join(\
            ["%s.%s = %%(%s)s " % (r_tbl,v,k)\
                for k,v in r_key.iteritems()])

        return s

    def _sqlBuildFilter(self,filter,prefix=False,tbl=None):
        """ _sqlBuildFilter(self,filter[,prefix,tbl]) --> str

        Build the filter as SQL string. filter could be
        a string, a dict or a list (in such case use internal store).
        """

        t=type(filter)
        if t==str:
            s=filter
        elif t==dict:
            s=self._sqlFieldsEq(filter,tbl)
            s=self._sqlMogrify(s,filter)
        elif t==set or t==frozenset or t==list:
            s=self._sqlFieldsEq(filter,tbl)
            s=self._sqlMogrify(s)
        else:
            self.log_int_raise(\
                "Invalid filter type for %s.",\
                    RED(str(filter)))

        return prefix and\
            " WHERE %s " % s or s

    def _sqlMogrify(self,s,d=None):
        """ A wrapper to dbda.mogrify that take
        self._store as default dict value.
        """
        d=d or self._store
        return self.mogrify(s,d)

#
##
### Core.
##
#
    def _setOid(self,params=None,safe_mode=True):
        """ _setOid([params=None,safe_mode=True]) --> None

        Load OID from DB using self.pkeys.
        If not all pkeys are present, InternalError is raised.
        If params is given, query is restricted with these values.
        """

        # Really need it?
        if self.oid is not None:
            self.log_insane("Why are you loading OID? I got it.")
            return 

        params=params or set([])
        # In safe mode, pkeys and params are sufficient.
        if safe_mode:
            params|= self.pkeys
        # If this is an unsafe call, use all
        # values present on store to filter the query.
        # Crash if there is no filter.
        else:
            params|= set(self._store.keys())
            if not params:
                self.log_int_raise(
                    "Mth: no filter to get OID "
                    "in unsafe mode.")


        # safe_mode (default):
        # Are all pkeys given?
        # CRASH otherwise.
        if safe_mode:
            ange=self._unvaluedPKeys()
            if ange:
                self.log_int_raise(
                    "Mth: cannot load OID: %s",
                    RED(str(ange)))

        # Build query ...
        qry=  self._sqlSelectWhat("oid")
        qry+= self._sqlBuildFilter(params, prefix=True)

        # ... and execute it
        try:
            self.oid= self.ov_query(qry)
        except:
            self.log_int_raise(
                "Mth: cannot retrieve OID "
                "with params: %s",
                RED(str(params)))

#
##
### Public Methods
##
#    

    def isPureRelation(self,params=None):
        """ isPureRelation --> None

        The MoThEr Core, the Holy Hearth.
        """
        if params is None:
            return "I s P u R e R e L a T i O n !"
        else:
            return "Mi Sembva Di Impazzive."

    def isFatherOf(self,table_name):
        """isFatherOf(table_name)-->boolean

        Params: string(table_name)
        """
        from rels import TABLE_CHILDS_DICT
        result=(table_name in TABLE_CHILDS_DICT[self.table_name].keys())
        del TABLE_RELATIONS_DICT
        return result

    def isMarriedOf(self,table_name):
        """isMariedOf(table_name)-->boolean

        Params: string(table_name)
        """
        from rels import TABLE_RELATIONS_DICT
        result=(frozenset(self.table_name,table_name) in TABLE_RELATIONS_DICT.keys())
        del TABLE_RELATIONS_DICT
        return result

    def isChildOf(self,table_name):
        """isChildOf(table_name)-->boolean

        Params: string(table_name)
        """
        from rels import TABLE_CHILDS_DICT
        result=(self.table_name in TABLE_CHILDS_DICT[table_name].keys())
        del TABLE_CHILDS_DICT
        return result

    def get_triggers(self, flag, when):

        if not self._triggers_are_initialized():
            self.log_int_raise("Trigger are not initialized.")

        t= self.triggers_map
        try:
            d= t[flag]
        except:
            self.log_int_raise("add_trigger(): invalid flag %s.", RED(flag))

        try:
            l= d[when]
        except:
            self.log_int_raise("add_trigger(): invalid time %s.", RED(when))

        return l

    def get_flag_triggers(self, flag):
        l=[]
        l+= self.get_triggers(flag, MO_BEFORE)
        l+= self.get_triggers(flag, MO_AFTER)
        return l

    def add_trigger(self, flag, when, trigger):
        """ add_trigger(flag, when, f) --> None

        flag= MO_LOAD, MO_SAVE, MO_DEL, MO_UP
        when= MO_AFTER, MO_BEFORE

        f is the trigger: a python function
        """

        if not self._triggers_are_initialized():
            self.initTriggers()

        self.triggers_map[flag][when].append(trigger)

    def trigger(self, flag, when, *args):
        """ trigger(flag, when, *args) --> None

        flag= MO_LOAD, MO_SAVE, MO_DEL, MO_UP
        when= MO_AFTER, MO_BEFORE

        execute the tasked triggers for action flag and when
        """

        if not self._triggers_are_initialized():
            self.log_int_raise("Triggers are not initialized.")

        l= self.get_triggers(flag, when)
        for f in l:
            f(*args)

    def setField(self,field_name,field_value):
        """ setField(field_name,field_value) --> None

        Update the store with field_name and field_value.
        """

        # Pkeys cannot be changed! It's a non-sense.
        # If you want insert a new record, create new MoThEr 
        # If you want to load a different record, use refresh()
        if field_name in self.pkeys:
            self.log_int_raise(
                """ For your safety, you can not change Pkeys Value.
                Want to load a new record? Use refresh()
                Want to update a Pkey? Create new and delete old.
                """)

        if field_name not in self.fields:
            self.log_int_raise("Mth: cannot setField(): field "\
                    "%s is invalid.",RED(field_name))

        # Ok, new value is good
        self._store[field_name]=field_value
        # Remember that a field is changed.
        self._moved.add(field_name)

    def setFields(self,fdict,safe_mode=True):
        """ setFields(fdict,[safe_mode=True]) --> None

        Update the store with fdict. 
        If `safe_mode`, it will be forbidden to change 
        primary keys value. Really, use safe_mode iff
        you know exactly what are you doing.

        """
        # Is fdict a valid dict?
        new_fields=set(fdict.keys())
        onzo=self._invalidFields(new_fields)
        if onzo:
            self.log_int_raise("Mth: cannot setFields(): "\
                    "invalid fields %s.", RED(str(onzo)))

        # Cannot change pkeys
        if safe_mode:
            sp=self.pkeys
            if sp & new_fields:
                self.log_int_raise(
                    "For your safety, you can not change Pkeys Value. "
                    "Want to load a new record? Use refresh(). "
                    "Want to update a Pkey? Create new and delete old. "
                    "If you know what you do, use safe_mode=False. "
                    )

        # Ok, new values are good.
        self._store.update(fdict)
        # Remember fields changed.
        self._moved |= new_fields

    def getFields(self,fields=None,autoload=False):
        """ getFields([fields=None,autoload=False]) --> dict

        Returns stored values.
        If fields is not None, returns values for fields specified.
        If a field is invalid, CRASH.
        If a field is unvalued:
            if autload: load
            if not autoload: CRASH
        """

        if fields is None:
            return self._store.copy()

        onzo=self._invalidFields(fields)
        if onzo:
            self.log_int_raise("Mth: cannot setFields(): "\
                    "invalid fields %s.", RED(str(onzo)))
        newd={}
        if autoload:
            self.log_insane("Autoloading fields...")
            skeys=set(self._store.keys())
            nkeys=set(fields)
            lkeys=nkeys-skeys
            if len(lkeys):
                self.load(lkeys)
            
        for f in fields:
            try:
                val=self._store[f]
                newd[f]=val
            except:
                self.log_int_raise(\
                    "Mth: field %s is not valued.",\
                        RED(f))
        return newd

    def _insert(self):

        # Is record stored yet?
        if self.oid:
            self.log_int_raise("Mth: cannot insert(): record is attached, "\
                "OID=%s. Want to use update()?",RED(self.oid))

        s=self._store
        # Debugging control and informations.
        if len(s)<len(self.fields):
            self.log_insane( 
                    "Mth: key values not completely specified:"
                    " assuming DEFAULT value.")

        # Useful vars
        sk=s.keys()

        # Make the query ...
        q=self._sqlInsertFields(sk)
        q+=self._sqlFieldsDicted(sk)
        qry=self._sqlMogrify(q)

        # otherwise execute it ...
        res=self.oc_query(qry)
        # and get last oid
        self.oid=self.lastrowid()

        # Useful debugging infos...
        self.log_insane(
                "Mth: %s saved with oid %s.",
                GREEN(str(s)),GREEN(str(self.oid)))

        # Load primary keys if not specified  
        # on INSERT
        ing=self._unvaluedPKeys()
        if ing:
            self.log_insane(
                    "Loading missing pkeys %s",
                    YELLOW(ing))
            self._load(ing)

        else:
            self.log_insane(
                    "No pkey has to be loaded.")

    def _update(self):

        # Really need to update?
        if not self._moved:
            self.log_int_raise("Mth: nothing to update.")

        # If we don't have OID, load it....
        self._setOid()

        # So, we got OID ;)
        # Make the query ...
        q=self._sqlUpdateFields(self._moved)
        q+=self._sqlWhereOid()
        qry=self._sqlMogrify(q)

        # else execute it
        try:
            res=self.oc_query(qry)
        except QueryError,ange:
            self.log_raise(str(ange), UpdateError)

        # Debugging infos...
        self.log_insane( "Mth: fields %s moved ;)",
                GREEN(self._moved))

        # Nothing has to be updated now.
        self._moved.clear()

    def _delete(self):

        # The values in store act as filters
        # when deleting
        params= set(self._store.keys())
        # If oid is not present, load it.
        # If cannot do that, CRASH!
        self._setOid(params= params)

        s=self._store
        # Make the query ...
        qry=self._sqlDelete()
        qry+=self._sqlWhereOid()

        # else execute it
        try:
            self.oc_query(qry)
        except QueryError, ange:
            self.log_raise(str(ange), DeleteError)

        # Debugging infos...
        self.log_insane( 
                "Removed record with OID %s, "
                "values %s",GREEN(self.oid),GREEN(s))

        # Delete all informations...  
        self._moved.clear()
        self._store.clear()
        self.oid=None
        s.clear()

    def _load(self,fields=None,safe_mode=True):

        # Getting OID with all valued fields
        self._setOid(safe_mode=safe_mode)

        # Which fields we need?
        mf=fields and set(fields) or self._fieldsMissing()

        # if nothing has to be loaded, oid is sufficient
        if not mf:
            self.log_insane(
                    "load(): OID (%s) already loaded. "\
                    "Fields to load not specified. "\
                    "Store is complete. will not SELECT.",\
                    YELLOW(self.oid))
            return

        # Make the query ...
        qry=self._sqlSelectFields(mf)
        qry+=self._sqlWhereOid()

        # else execute it
        try:
            res=self.or_query(qry)
        except QueryError,ange:
            self.log_raise(str(ange), SelectError)

        self.log_insane( "Loaded fields for OID=%s: %s",
                    GREEN(self.oid),GREEN(str(res)))

        # Update values on store
        self._store.update(res)

        # Forgot old to-update fields  
        self._moved-=mf

        # Useful return, that's all
        return res

    def _triggered_action(self, flag, *args):

        f=self._trigger_actions[flag]

        if not self._triggers_are_initialized() or \
                not self.get_flag_triggers(flag):

            if len(args)==0:
                res= f()
            else:
                res= f(*args)

        else:
            self.beginTrans()
            try:
                self.log_insane(
                        "Launching %s triggers...",
                        GREEN('before'))
                self.trigger(flag, MO_BEFORE)

                self.log_insane( 
                        "Executing %s action...",
                        GREEN(_MO_FLAGS_STRS[flag]))

                if len(args)==0:
                    res= f()
                else:
                    res= f(*args)

                self.log_insane( 
                        "Launching %s triggers...",
                        GREEN('after'))

                self.trigger(flag, MO_AFTER)

            except Exception, s:
                self.rollback()
                self.log_int_raise(str(s))

            self.commit()

        self.log_info("Action %s.", GREEN("completed"))
        return res

    def delete(self):
        """ delete() --> None

        Really do you want to kill me?
        """
        self._triggered_action(MO_DEL)
    
    def load(self,fields=None,safe_mode=True):
        """ load([fields=None,safe_mode=True]) --> dict

        Retrieve record values from DB. 
        if fields is not None, only fields specified will
        be loaded.
        Fields loaded will be removed from to-update fields.
        If safe_mode is False, try to load the record also if
        primary keys was not given.
        """
        self._triggered_action(MO_LOAD,fields,safe_mode)

    def insert(self):
        """ insert() --> None

        Insert to db the values stored in store.
        For field with no value, SQL_DEFAULT is assumed.
        """
        self._triggered_action(MO_SAVE)
        
    def update(self):
        """ update() --> None

        Make a UPDATE sql statement for modified fields.
        """
        self._triggered_action(MO_UP)

    def uload(self,fields=None):
        """ uload([fields=None]) --> dict

        This is a call to load() with safe_mode=False
        """

        return\
            self.load(fields,safe_mode=False)

    def refresh(self,d,flag=MO_NOA):
        """ refresh(d[,flag=MO_NOA]) --> None

        You can secify here a new set of pkeys and
        have a new, fresh mother
        """
        # Detach record from db
        self.oid=None
        # init store.
        self._initStore(d,flag)


class MotherFly(DbMother):
    def __init__(self, tbl):
        self.table_name= tbl

    def __call__(self, d= {}, flag= MO_NOA, oid= None, dbda= None):
        DbMother.__init__(self, d, flag=flag, oid= oid, dbda=dbda)
        return self


def getMotherBuilder(tbl):
    """ getMotherBuilder(tbl_name) --> class

    Returns a `MoThEr Builder On The Fly` Class.
    You can init the class with a simple call:

        momma= getMotherBuilder(table)
        momma(mydict, myflag)
    """
    momma= MotherFly(tbl)
    return momma


def getMotherObj(tbl, d={}, flag= MO_NOA, dbda= None, logger= None):
    """ getMotherObj(tbl_name[,diz,flag]) --> obj

    Initialize and return a `MoThEr On The Fly` Class.
    """
    momma= getMotherBuilder(tbl)
    momma(d, flag=flag, dbda=dbda)
    return momma

#
##
### The MoThEr Manager
####
#####


class MotherManager:
    """ Mother Manager-Plugin. Need Mother."""

#
##
### Internal use.
##
#

    def _sqlJoinParent(self, builder, j_builder, outer=False):
        """ _sqlJoinParent(self,j_builder,builder,outer=False) --> (string, string)

        Returns a filter and the table where filter has to be made.
        """
        from rels import TABLE_CHILDS_DICT,TABLE_RELATIONS_DICT

        tbl= builder.table_name
        j_tbl= j_builder.table_name

        if j_tbl not in TABLE_CHILDS_DICT[tbl].keys():

            rel= frozenset([tbl,j_tbl])

            try:
                j_tbl= TABLE_RELATIONS_DICT[rel]
            except:
                self.log_int_raise('_sqlJoinParent: invalid join'\
                        ' table %s!' % RED(j_tbl))

            self.log_insane( 
                    "Joining relations %s", 
                    YELLOW(j_tbl))

        else:
            self.log_insane( 
                    "Joining child %s", 
                    YELLOW(j_tbl))

        m_d= self.getChildDeps(j_tbl, builder)

        del TABLE_CHILDS_DICT, TABLE_RELATIONS_DICT

        if outer:
            s=" LEFT OUTER JOIN %s on " % j_tbl
        else:
            s=" JOIN %s on " % j_tbl

        s+="AND".join(\
            [" %(tbl)s.%(k)s = %(j_tbl)s.%(v)s " % locals()
            for k,v in m_d.iteritems()])

        return s, j_tbl

    def _getRelationObject(self,builders):
        """ _getRelationObject(self,builders): --> object
        object is a MotherOnTheFly object.
        builders are a list of table names.
        """

        # Obsolete
        ######################
        ### WORK # ON # THAT #
        ######################
        
        rel_tbl_name=self._searchRelation(builders+ [self.table_name])

        # Return a builder with MotherOnTheFly.
        rel_obj=getMotherObj(rel_tbl_name)
        return rel_obj

    def getChildDeps(self,tbl_name,father=None):
        """ getChildDeps(builder[,father=None]): ---> dict
        Wich fields in TABLE tbl_name will be inherited from father?
        Returned dict is the mapping_dict.
        If father is None, self is assumed.
        """

        father=father or self
        tbl=father.table_name

        # Load father children.....
        from rels import TABLE_CHILDS_DICT
        d=TABLE_CHILDS_DICT[tbl]
        del TABLE_CHILDS_DICT

        # Get the dependencies for child tbl_name
        try:
            dd=d[tbl_name]
        except:
            self.log_int_raise(\
                "Child %s not specified for table %s.",\
                    RED(tbl_name),RED(tbl))
        return dd

    def _getDepDict(self,mapping_dict,father=None):
        """_getDepDict(mapping_dict[,father=None]): ---> dict

        Given the dependencies mapping_dict, a new dict is created,
        filled and returned with father values.
        If father is None, self is assumed.
        """

        father=father or self
        new_d={}

        self.log_insane( 
                "Exporting values %s ",
                str(mapping_dict))
                        
        fkeys=set(mapping_dict.keys())
        try:
            d=father.getFields(fkeys)
        except Exception,s:
            self.log_int_raise(
                "in _getDepDict, unable to get values: "\
                "father= %s. getFields -> %s",\
                            str(father),str(s))
            
        for mapkey in mapping_dict:
            mapped_field=mapping_dict[mapkey]
            new_d[mapped_field]=d[mapkey]

        return new_d

    def _fillChildDict(self,child_obj,father=None):
        """_fillChildDict(child_obj[,father=None]) --> None
        Given a child object, his store is updatetd with
        father dependencies. If father is None, father=self.
        """
        
        father=father or self
        ct=child_obj.table_name
        
        # Ge dependencies ...
        d=self.getChildDeps(ct,father)
        # Create new dict ...
        new_d=self._getDepDict(d,father)
        # Init child with new_dict
        child_obj.setFields(new_d,safe_mode=False)

        self.log_insane( 
                "Child object(%s) updated with values %s.",\
                GREEN(ct),GREEN(new_d))

    def _workChild(self,child_builder,child_dict,flag):
    
        # Build obj...
        new_obj=child_builder(child_dict)
            # Inherit father fields...
        self._fillChildDict(new_obj)
                # Get properly function...
        f=new_obj._flag_actions[flag]
                    # Get some debugging vars
        tbl=new_obj.table_name
        sd=str(new_obj.getFields())
        s=_MO_FLAGS_STRS[flag]
                # Execute function....
        f()
            # Debug
        self.log_insane( 
                "%s child %s, values %s",
                s,tbl,sd)

        return new_obj
        # Return ;)

    def _searchRelation(self,tbls):

        fz=frozenset(tbls)

        from rels import TABLE_RELATIONS_DICT
        try:
            r_tbl=TABLE_RELATIONS_DICT[fz]
            self.log_insane(
                    "Using relation %s to join "\
                    "tables %s",\
                    r_tbl,tbls)
        except:
            self.log_info(\
                "Warning: direct relation for set %s "\
                "is not defined: searching subset...",\
                YELLOW(fz))
            rels=[\
                TABLE_RELATIONS_DICT[k]\
                for k in TABLE_RELATIONS_DICT.keys()\
                if fz<k ]

            if len(rels)<>1:
                self.log_int_raise(
                    "In getRelation: can not get the "\
                    "relation table. There are %s "\
                    "possible choices: %s .",\
                    RED(len(rels)), RED(",".join(rels)))
            r_tbl=rels[0]
            del TABLE_RELATIONS_DICT
        return r_tbl

       
#
##
### Public
##
#

    def getChild(self,c_builder,c_dict):
        """ getChild(c_builder,c_dict): --> MotherObj
        """
        return self._workChild( 
                                c_builder,
                                c_dict,
                                MO_LOAD,
                              )
                                    

    def insertChild(self,c_builder,c_dict):
        """ insertChild(child_builder,c_dict) -> MotherObj
        insert new child object and return it.
        """
        return self._workChild( 
                                c_builder,
                                c_dict,
                                MO_SAVE,
                              )

    def updateChild(self,c_builder,c_dict):
        """ updateChild(c_builder,c_dict): --> MotherObj
        """
        return self._workChild( 
                                c_builder,
                                c_dict,
                                MO_UP,
                              )
        
    def deleteChild(self,c_builder,c_dict):
        """ deleteChild(c_builder,c_dict): --> MotherObj
        """
        return self._workChild( 
                                c_builder,
                                c_dict,
                                MO_DEL,
                              )

    def deleteChildren(self,c_builder,filter=None):
        """ deleteChildren(c_builder,filter=None) --> None
        
        Delete a set of children, filtered with filter.
        If filter is None, delete all children.
        """
        child_table= c_builder.table_name
        d= self.getChildDeps(child_table)
        d= self._getDepDict(d)

        qry_filter= self._sqlBuildFilter(d, tbl=child_table)
        if filter is not None:
            qry_filter+= " AND %s" % \
                    self._sqlBuildFilter(filter, tbl=child_table)

        MotherBox(c_builder, qry_filter, MO_DEL)

    def updateChildren(self, c_builder, d_up, filter= None):
        """ updateChildren(self, c_builder, d, filter= None): --> None

        Update children with dict d_up.
        If filter, update only filtered children.
        """
        child_table= c_builder.table_name
        d= self.getChildDeps(child_table)
        d= self._getDepDict(d)

        # Build filter
        qry_filter= self._sqlBuildFilter(d, tbl=child_table)
        if filter is not None:
            qry_filter+= " AND %s" % \
                    self._sqlBuildFilter(filter, tbl=child_table)

        MotherBox(c_builder, flag=MO_UP, up_dict= d_up, filter= qry_filter) 

    def getChildren(self,c_builder,fields=None,filter=None,\
                    builder_join=None,filter_join=None,outer=False,order=None):
        """
        getChildren(c_builder[,fields=None,filter=None,
            builder_join=None,filter_join=None,outer=False,order=None])-->box
        
        params:
        fields = list of fields names
        filter = string or dictionary
        builder_join = builder class which will be joined
            it will use SELECT DISTINCT
        filter_join = string or dictionary about join table fields
        outer = boolean, will be a left outer join
        order = string, field of order
        """

        child_table=c_builder.table_name
        # Get dependencies dict...
        d=self.getChildDeps(child_table)
        d=self._getDepDict(d)

        # If a join filter is specified, we need
        # to build the JOIN STATEMENT before the WHERE
        qry_filter, joining_table= builder_join and \
            self._sqlJoinParent(c_builder, builder_join, outer) or \
                ("", "")

        # Build SQL filter string
        qry_filter+=" WHERE "

        # now filter father dependencies
        qry_filter+=self._sqlBuildFilter(d, tbl= child_table)

        # Filter join condition
        # Note that the filter is used on the joined table
        # that is returned by _sqlJoinParent
        if builder_join and filter_join:
            qry_filter+=" AND %s " %\
                self._sqlBuildFilter(\
                filter_join, tbl= joining_table)

        # if filter is specified, use it ...
        # the filter `filter` is used on Child Table.
        if filter is not None:
            qry_filter+=" AND  %s " %\
                self._sqlBuildFilter(filter,tbl=child_table)

        # Let's use a MotherBox :)
        # If join use DISTINCT
        distinct=(builder_join is not None)
        mb=MotherBox(c_builder, filter= qry_filter, flag= MO_LOAD,\
            fields= fields, order= order, distinct= distinct)
        # Oh yes, return ;)
        return mb

    def assignRelation_nt(self,builder_list,params={}):
        """ """

        # Handle given objects ...
        builders=[]
        fathers=[]
        self.log_insane("Creating auto-relation...")

        for builder,d,flag in builder_list:
            tbl=builder.table_name
            builders.append(tbl)
            flag_str=_MO_FLAGS_STRS[flag]
            self.log_insane(
                    "Working record in %s with "\
                    "values %s and flag=%s...",\
                    YELLOW(tbl),YELLOW(str(d)),flag_str)
            try:
                new_obj=builder(d,flag)
                fathers.append(new_obj)
            except Exception,s:
                es=("Error! %s initialization returned: %s."\
                              " Now Rollback!" % (flag_str,RED(str(s))))
                self.log_error(es)
                self.log_int_raise("Unable to assign child: %s",es)

        self.log_insane( 
                "%s child(ren) assigned, now work on "\
                "relation...",GREEN(len(builders)))

        # create auto relation ...
        # init child object 
            
        # self.table_name is added automatically
        r_obj = self._getRelationObject(builders)

        # Let child take his values from fathers...
        for father in [self]+fathers:
            self._fillChildDict(r_obj,father)
        r_obj.setFields(params,safe_mode=False)

        # store it to DB
        try:
            q=r_obj.insert()
        except Exception,s:
            self.log_error("Error! insert() returned: %s."\
                                " Now Rollback!",RED(str(s)))
            self.log_int_raise("Error adding auto-relation.") 

        # All was fine.
        self.log_insane( 
                "Relation %s auto-saved with "\
                "values %s.",r_obj.table_name,\
                GREEN(str(r_obj._store)))

        return tuple(fathers)

    def assignRelation(self,builder_list,params={}):
        """ assignRelation(self,builder_list,params={}) --> Tuple

        Hanlde a set of tables that, with self, define a relation
        TABLE.
        builder_list is a list of tuples:

            [(MotherBuilder,dict,flag)...]

        If TABLE A and TABLE B are related with the relation TABLE
        R_AB, you can:

            me=A
            builder_list=[(B,dict,MO_SAVE)]
            assignRelation(builder_list)

        with this call, create a record in B and put in R_AB the 
        relation.
        If the relation accept other fields, specify them in params,
        which is a dict.
        """

        self.beginTrans()
        try:
            res=self.assignRelation_nt(builder_list,params)
        except Exception,s:
            self.rollback()
            raise Exception(s)

        self.commit()
        return res
            
    def dropRelation(self,builder_list,params={}):
        """ dropRelation(self,builder_list,params={}) --> list

        Drop relation between father in builder_list.
        builder_list is [(builder,dict,flag),...]
        """
        fathers=[]
        fathers_del=[]
        # Create the list of only builders
        for builder,d,flag in builder_list:
            new_obj=builder(d)
            fathers.append(new_obj)
            if flag==MO_DEL:
                fathers_del.append(new_obj)

        # create auto relation init child object
        t_names=[o.table_name for o in fathers]
        r_obj = self._getRelationObject(t_names)
        
        # Let child take his values from fathers...
        for father in [self]+fathers:
            self._fillChildDict(r_obj,father)

        r_obj.setFields(params)
        r_obj.delete()
        self.log_insane("Dropped relation %s",\
                GREEN(r_obj.table_name))
        # Destroy all fathers with flag MO_DEL
        for f in fathers_del:
            f.delete()
        return fathers
    
    def dropRelations(self,builder,filter=None,\
                        r_tbl=None,flag=MO_NOA):
        """ dropAllRelation(self,builder,filter=None,\
                                r_tbl=None,flag=MO_NOA):

            drop all related records.
            If r_tbl is specified, use that table to
            join records.
            Otherwise, r_tbl is deduced.
            fIlter is.. a filter.
        """

        mbox=self.joinRelation(builder, filter= filter, r_tbl= r_tbl)

        self.log_insane( 
                "%s is dropping %s relation(s) ...",
                YELLOW(self.table_name), YELLOW(len(mbox)))

        ds=mbox.getFields()
        for d in ds:
            self.dropRelation([(builder,d,flag)])

    def joinRelation(self,builder,fields=[],\
                        filter=None,r_tbl=None,order=None):
                        
        """ joinRelation(self,builder[,fields=[],
                        filter=None,r_tbl=None,order=None])
                                    -->  MotherBox

        Get related data.
        Builder is the MotherBuilder for data to be searched.
        Filter could be a string or a dict: if given, query will
        be restricted. Note that filter will be applied to the
        relation table.
        r_tbl is the relation table used for the join. If not given,
        r_tbl is searche dautomaically (see dbmapper.py and rels.py).
        if order is not None, the query will be ordered by fields
        in order.
        """

        # Useful vars
        s_tbl=self.table_name
        b_tbl=builder.table_name

        # Try to get relation table....
        # If not specified, serach on rels.py
        # If there is ambiguity, CRASH!
        if r_tbl is None:
            r_tbl=self._searchRelation([s_tbl,b_tbl])

        # Ok, the relation table is found
        # Getting the mapping child dicts
        s_d = self.getChildDeps(r_tbl)
        b_d = self.getChildDeps(r_tbl,builder)
        
        # If fields is not specified, fields for the
        # serached table is retrieved by dbstruct.py
        if fields==[]:
            from dbstruct import TABLE_FIELDS_DICT
            fields=TABLE_FIELDS_DICT[b_tbl]
            del TABLE_FIELDS_DICT

        self.log_insane("Joining %s and %s with relation %s "\
                        "and fields %s ...",s_tbl,b_tbl,\
                        YELLOW(r_tbl),YELLOW(str(fields)))
                        
        # Make the filter query ...
        qry_filter = self._sqlJoin(b_tbl,r_tbl,b_d,s_d)
        # If filter is given, apply it.
        if filter:
            tbl=builder.table_name
            qry_filter+=" AND %s " % self._sqlBuildFilter(filter,tbl=r_tbl)
        # Mogrify the obtained filter query ...
        qry_filter=self._sqlMogrify(qry_filter)

        # get a MotherBox
        mb=MotherBox(builder,qry_filter,MO_LOAD,fields,order)
        return mb

    def initChildManager(self,children):
        """initChildManager(self,children) --> None
        
        You can define a Mother class for each Child-TABLE.
        In fact, children is a list of Mother Builders.
        Aall this method to have a set of wrappers for the 
        functions:
            
            insertChild(Foo,dict)
            deleteChildren(Foo, filter)
            updateChildren(Foo, dict, filter)
            getChildren(builder,fields,filter,builder_join,filter_join,outer,order)


        So, if FOO is a child, you can create the Mother Class
        Foo and have the methods:

            getFoo(dict)
            deleteMultipleFoo(filter)
            updateMultipleFoo(dict, filter)
            getMultipleFoo(fields, filter, builder_join, filter_join, outer, order)

        NOTE: methods already defined are not overwritten.
        """

        insertchild= lambda builder:(                   \
                        lambda idict:                   \
                            self.insertChild(builder, idict))

        deletechildren= lambda builder:(                \
                            lambda filter=None:         \
                                self.deleteChildren(builder, filter))

        getchildren= lambda builder:(                                                   \
                        lambda fields=None,filter=None,                                 \
                            builder_join=None,filter_join=None,outer=None,order=None:   \
                                self.getChildren(                                       \
                                            builder,                                    \
                                            fields,                                     \
                                            filter,                                     \
                                            builder_join,                               \
                                            filter_join,                                \
                                            outer,                                      \
                                            order))

        updatechildren= lambda child:(                  \
                            lambda d_up, filter= None:  \
                                self.updateChildren(child, d_up, filter))

        for c in children:
            ctbl=c.table_name

            attr_name= camelName(ctbl,'insert')
            if not hasattr(self, attr_name): 

                attr= insertchild(c)
                attr.__doc__=\
                        """ %s(dict) --> child\n\n\
                        insert a child. dict contains the fields values.\n\
                        Don't specify the foreign key: it's assigned automatically.\n"""\
                            % attr_name

                setattr(self, attr_name, attr)

            attr_name= camelName(ctbl, 'deleteMultiple')
            if not hasattr(self, attr_name): 
                
                attr= deletechildren(c)
                attr.__doc__=\
                        """ %s(filter= None) --> None\n\n\
                        delete children. if filter is None, delete ALL children."""\
                            % attr_name

                setattr(self, attr_name, attr)

            attr_name= camelName(ctbl, 'getMultiple')
            if not hasattr(self, attr_name): 
                
                attr= getchildren(c)
                attr.__doc__=\
                        """ %s([fields= None, filter= None, builder_join= None, \
                        filter_join, outer= None, order= None) --> MotherBox\n\n\
                        retrieve a set of children. filter is used for the children table.\n\
                        builder_join and filter_join are used to do advanced filtering.\n\
                        If outer is True, an outer join is performed.\n\
                        order is a list of fields names.""" % attr_name

                setattr(self, attr_name, attr)

            attr_name= camelName(ctbl, 'updateMultiple')
            if not hasattr(self, attr_name): 
                
                attr= updatechildren(c)
                attr.__doc__=\
                        """ %s(d_up, filter= None) --> None\n\n\
                        update children. the dict d_up contains the fields (and their values)
                        to be updated. The filter is a usual filter.
                        """ % attr_name

                setattr(self, attr_name, attr)

    def initRelationManager(self,children):
        """initRelationManager(children) --> None
        
        This is a magic function.
        It's a wrapper for the methods:

            - assigRelation
            - joinRelation
            - dropRelation
            - dropRelations

        The wrappers will be:

            - assigFoo
            - joinFoo
            - dropFoo
            - dropMultipleFoo

        NOTE: methods already defined are not overwritten.
        """

        d={
            self.assignRelation:"assign",
            self.dropRelation:"drop"
        }

        magic = lambda handler,child:(\
                lambda d,flag=MO_NOA,params={}:\
                    handler([(child,d,flag)],params)[0])

        b={
            self.joinRelation:'join',
            }
            
        logic = lambda handler,builder:(\
                lambda fields=[],\
                       filter=None,\
                       r_tbl=None,\
                       order=None:\
                        handler(builder,fields,\
                                 filter,r_tbl,order))

        g={
            self.dropRelations:'dropMultiple',
        }

        gigic = lambda handler,child:(\
                lambda filter=None,\
                       r_tbl=None,\
                       flag=MO_NOA:
                        handler(child,filter,r_tbl,flag)) 

        for child in children:
            c=child.table_name
            for f,pref in d.iteritems():
                attr=magic(f,child)
                attr_name=camelName(c,pref)
                # Don't let initRelationManager overwrite
                # user methods
                if hasattr(self,attr_name):
                    continue
                attr.__doc__=\
                    """ %s(dict[,flag=MO_NOA,params={}]) --> obj

                    Handle the Mother object created with dict and flag,
                    but after insert one record on the relation table that
                    join %s and %s.
                    Return the handled Mother Object."
                    """ % (attr_name,self.table_name,c)
                setattr(self,attr_name,attr)
            
            for f,pref in b.iteritems():
                attr=logic(f,child)
                attr_name=camelName(c,pref)
                # Don't let initRelationManager overwrite
                # user methods
                if hasattr(self,attr_name):
                    continue
                attr.__doc__=\
                    """ %s([,fields,filter,r_tbl,order]) --> MotherBox

                    Do a join with records in %s.
                    If filter is specified, apply it.
                    If r_tbl is specified, use that as relation table to make the join.
                    If fields is specified, load only these fields from the joined table.
                    Return a MotherBox object.
                    """  % (attr_name,c)
                setattr(self,attr_name,attr)

            for f,pref in g.iteritems():
                attr=gigic(f,child)
                attr_name=camelName(c,pref)
                # Don't let initRelationManager overwrite
                # user methods
                if hasattr(self,attr_name):
                    continue
                attr.__doc__=\
                    """ %s(filter,r_tbl,flag) --> None

                    Drop a set of relations.
                    if flag is specified, do the relative action
                    on related records.
                    if r_tbl is specified, use that table to make the join.
                    """  % (attr_name)
                setattr(self,attr_name,attr)


class DictOid:
    def __init__(self,oid,d):
        self.oid=oid
        self.store=d
    def cmp(self,d):
        s=self.store
        for k,v in d.iteritems():
            if v<>s[k]:
                return False
        return True

class MotherBox(Speaker, Psygres):
    def __init__(self,builder,filter,flag=MO_NOA,fields=None,order=None,up_dict=None,distinct=False):
        """ __init__(builder,filter[,flag=MO_NOA,fields=[],order= None,up_dict=None,distinct=None]) 

        builder is a DbMother builder.
        filter is a dict or a string.
        flag could be MO_NOA,MO_DEL,MO_LOAD.
        fields: if specified, and with MO_LOAD, only that
        fields will be loaded from DB.
        up_dict is considered only with flag=MO_UP and contains
            the dict for the update.
        distinct set DISTINCT kword after SELECT
        """

        self.order= order

        self.builder= builder
        self.table_name= tbl= builder.table_name

        self._store= []

        if flag==MO_LOAD:
            self.loadBox(filter,fields,distinct)
        elif flag==MO_DEL:
            filter= filter or ''
            self.deleteBox(filter)
        elif flag==MO_UP:
            self.updateBox(up_dict, filter)
        else:
            pass

    def __len__(self):
        return len(self._store)

    def _retrieve_oided_mothers(self, filter):
        where= filter and self._sqlBuildFilterBox(filter, prefix= True) or ''
        tbl= self.table_name
        qry= "SELECT %(tbl)s.oid from %(tbl)s %(where)s" % locals()

        res= self.mr_query(qry)
        mothers= [self.builder(oid=d['oid']) for d in res]

        return mothers

    def _retrieve_stored_mothers(self):
        mothers= [self.builder(oid=d['oid']) for d in self.getFields()]
        return mothers

    def _trigger_mothers(self, mothers, flag, when):
        if len(mothers):
            m= mothers[0]
            if not m._triggers_are_initialized() or \
                not m.get_flag_triggers(flag):
                    return

            for m in mothers:
                m.trigger(flag, when)

    def _sqlFieldsComma(self, store):
        """ _sqlFieldsComma(store) --> string

        Returns 'f_1=%(f_1)s,f_2=%(f_2), ....'
        or 'f=DEFAULT, ...' if store[f]=SQL_DEFAULT

        Ah, sure, store is a dict.
        """
        tl=[]
        for k,v in store.iteritems():
            if v==SQL_DEFAULT:
                tl.append(k+" = DEFAULT")
            else:
                tl.append(k+(" = %%(%s)s" % k))
        return ','.join(tl)


    def _sqlBuildFilterBox(self,filter,prefix=False):
        """ _sqlBuildFilterBox(self,filter, prefix= False) --> str

        Build the filter as SQL string. filter could be
        a string or a dict. 
        Note that WHERE is not included by default: you
        have to use prefix= True. By the way, if WHERE is already
        present in filter, it's not added.
        """

        s= None

        if filter is None:
            s= ''
        if isinstance(filter, str):
            s= filter

        if isinstance(filter, dict):
            if len(filter)==0:
                return ""
            tl=[(item+(" = %%(%s)s" % item)) for item in filter]
            s= " AND ".join(tl)
            s=self.mogrify(s,filter)
        
        if s is None:
            self.log_int_raise("Invalid filter type: %s" % 
                    RED(str(type(filter))))

        if not prefix or 'WHERE' in s:
                return s
        return " WHERE %s " % s 

    def loadBox(self, filter, fields= None, distinct= False):
        ms= self._retrieve_oided_mothers(filter)
        self._trigger_mothers(ms, MO_LOAD, MO_BEFORE)
        self._loadBox(filter, fields, distinct)
        self._trigger_mothers(ms, MO_LOAD, MO_AFTER)

    def _loadBox(self,filter,fields=None,distinct=False):
        """ loadBox(self,filter,fields,distinct=False) --> None

        load data from DB.
        if fields is specified, only that fields will be loaded.
        if distinct, it will be a SELECT DISTINCT
        """

        tbl=self.table_name
        self.log_insane(
                "Mbox: loading with filter=%s",\
                YELLOW(filter))
        
        dist = distinct and 'DISTINCT' or ''

        sel="SELECT %(dist)s %(tbl)s.oid,%(what)s FROM %(tbl)s %(where)s "

        if fields is None:
            what="%s.*" % tbl
        else:
            if not len(fields):
                self.log_int_raise("Ei, if you want to choose some "\
                                    "fields, do it correctly.")
            what=",".join(['%s.%s' % (tbl,f) for f in fields])

        if filter is not None:
            where=self._sqlBuildFilterBox(filter, prefix= True)
        else:
            where=''

        s=self._store
        qry= sel % locals()

        if self.order:
            qry_order= " ORDER BY %s"\
                % ','.join(self.order)
            qry+=qry_order

        res= self.mr_query(qry)
        for d in res:
            oid= d.pop('oid')
            s.append(DictOid(oid, d))

        self.log_debug("Loaded %s records on %s",\
                GREEN(len(s)),GREEN(tbl))

        self.log_info("Action %s.", GREEN("completed"))

    def _deleteBoxOid(self):
        s=self._store
        if len(s)==0:
            self.log_insane("MthBox: Nothing to delete.")
            return

        oids=["oid=%d" % r.oid for r in s]
        return " OR ".join(oids)

    def deleteBox(self,filter=None, stored= False):
        if stored:
            ms= self._retrieve_stored_mothers()
        else:
            ms= self._retrieve_oided_mothers(filter)

        self.log_insane("Before Box Triggering....")
        self._trigger_mothers(ms, MO_DEL, MO_BEFORE)
        self._deleteBox(filter, stored)
        self.log_insane("AFter Box Triggering....")
        self._trigger_mothers(ms, MO_DEL, MO_AFTER)

    def _deleteBox(self,filter=None, stored= False):
        """ deleteBox(self, filter= None, stored= False) --> None

        delete from DB.
        If stored is True, delete stored object.
        """

        if stored:
            if not len(self):
                self.log_insane("Box: nothing to delete")
                return
            self.log_insane("Box: deleting stored records")

            frecs= self.filterBox(filter, pop= True)
            oids=["oid=%d" % r.oid for r in s]
            where= " WHERE %s " % " OR ".join(oids)

        else: 
            self.log_insane(
                    "Mbox: deleting with filter=%s",\
                    YELLOW(filter))

            where= filter and self._sqlBuildFilterBox(filter, prefix= True) or ''

        tbl=self.table_name

        qry="DELETE FROM %(tbl)s %(where)s" % locals()
        self.oc_query(qry)
        self.log_insane("Records deleted.")

        self.log_info("Action %s.", GREEN("completed"))

    def updateBox(self, d, filter=None):
        ms= self._retrieve_oided_mothers(filter)
        self._trigger_mothers(ms, MO_UP, MO_BEFORE)
        self._updateBox(d, filter)
        self._trigger_mothers(ms, MO_UP, MO_AFTER)

    def _updateBox(self, d, filter=None):
        """ updateBox(self, d, filter=None): --> None

        Update a set of records.
        """

        if filter is not None:
            where= self._sqlBuildFilterBox(filter, prefix= True)
        else:
            filter= ''

        table= self.table_name
        what= self._sqlFieldsComma(d)
        what= self.mogrify(what, d)

        qry= "UPDATE %(table)s SET %(what)s %(where)s" % locals()
        qry= self.mogrify(qry, d)

        self.oc_query(qry)
        self.log_insane("Box: Updatetd records.")

        self.log_info("Action %s.", GREEN("completed"))

    def filterBox(self,filter,inverse=False, pop= False):
        """ filterBox(self,filter,pop=False) --> set

        for each stored object, if filter apply on it,
        return it.
        If inverse, filter is inverted.
        Results are pop'd from store.
        """

        # Matching ...
        popped= []
        for r in self._store:
            ok= r.cmp(filter)
            if ok <> inverse:
                popped.append(r)

        if pop:
            for p in popped:
                self._store.remove(p)

        self.log_insane("Filtered %s records", GREEN(len(popped)))

        return popped

    def getFields(self,filter=None,inverse=False,flag_obj=False,fields=None,cdict=None, pop= False):
        """ getFields(self,filter=None,inverse=False,flag_obj=False,fields=[],cdict=None,pop=False) --> list 

        Returns the stored objects.
        If filter is specified, exclude objects filtered (or, if inverse is True,
        exclude objects that don't match the filter).
        if flag_obj, returns a list of Mothers Objects (fields and cdict are ignored).
        If flag_obj is False, returns a list of dict.
        In such case, if fields is specified, returns only these fields.
        If cdict, each dict in the returned list will be updated with cdict.
        If pop, results will be deleted from local store (speeds up next calls).
        """

        if filter:
            s= self.filterBox(filter, inverse, pop) 
        else:
            s= self._store
            if pop:
                self._store= []

        res=[]
        for r in s:
            if flag_obj:
                oid= r.oid
                n= self.builder(r.store, oid= oid)

            else:
                d= pop and r.store or r.store.copy()
                if fields is not None:
                    for k in d.keys():
                        if k not in fields:
                            d.pop(k)
                if cdict:
                    d.update(cdict)
                n= d
            res.append(n)
        return res
            
